const ЗАДЕРЖКА = 100;


// // // //


УбратьВыбраннуюПаруФишекМаджонгаСЗадержкой = мир =>
{
    setTimeout(
        function() {
            мир.убранныеФишкиМаджонга = мир.выбранныеФишкиМаджонга.slice();
            мир.выбранныеФишкиМаджонга = [];
            мир.уведомить("изменили выбранные фишки маджонга");
            мир.уведомить("убрали фишки маджонга");
        },
        мир.задержкаУбиранияФишекМаджонга
    );
};


// // // //


ИсключитьИзВыбранныхФишекМаджонгаПервую = мир =>
{
    мир.выбранныеФишкиМаджонга.shift();
    мир.уведомить("изменили выбранные фишки маджонга");
};


// // // //


СравнитьПаруВыбранныхФишекМаджонга = мир =>
{
    // Удостоверяемся в наличии двух фишек.
    if (мир.выбранныеФишкиМаджонга.length != 2)
    {
        return;
    }
    var н1 = мир.выбранныеФишкиМаджонга[0];
    var н2 = мир.выбранныеФишкиМаджонга[1];
    var г1 = мир.фишкиМаджонга[н1]["🚩"];
    var г2 = мир.фишкиМаджонга[н2]["🚩"];
    if (г1 == г2)
    {
        мир.уведомить("выбрали пару фишек маджонга одной группы");
    }
    else
    {
        мир.уведомить("выбрали пару фишек маджонга разных групп");
    }
};


// // // //


ВыбратьФишкуМаджонга = мир =>
{
    var номер = мир.фишкаМаджонгаДляВыбора;
    // Отсекаем выбор одной и той же фишки.
    if (
        мир.выбраннаяФишкаМаджонга &&
        мир.выбраннаяФишкаМаджонга == номер
    ) {
        return;
    }
    мир.выбраннаяФишкаМаджонга = номер;
    мир.выбранныеФишкиМаджонга.push(номер);
    мир.уведомить("изменили выбранные фишки маджонга");
};


// // // //


ПодготовитьМеханикуМаджонга = мир =>
{
    мир.выбранныеФишкиМаджонга = [];
    мир.задержкаУбиранияФишекМаджонга = ЗАДЕРЖКА;
};